// ~/jpHMM/src/emissionPriors.h
/**************************************************************
 File name	: emissionPriors.h
 Author		: Anne-Kathrin Schultz
 Version	: 2.0
 Date		: Oct 2010

Content:

 Classes: EmissionPriors

 Read in of priors (pseudo counts) for emission probabilities
***************************************************************/

#ifndef _EMISSIONPRIORS_H
#define _EMISSIONPRIORS_H


using namespace std;


class EmissionPriors
{
   friend ostream& operator<<(ostream& s, const EmissionPriors& e);
   public:
      EmissionPriors(string infile);
      ~EmissionPriors(){};
      void check();

      vector<mytype> match_priors()  const {return m_match_priors;};
      vector<mytype> insert_priors() const {return m_insert_priors;};

  private:
      vector<mytype> m_match_priors;
      vector<mytype> m_insert_priors;
};

ostream& operator<<(ostream& s, const EmissionPriors& e);

#endif  // _EMISSIONPRIORS_H
