// ~/jpHMM/src/emissionProfile.h
/**************************************************************
 File name	: emissionProfile.h
 Author		: Anne-Kathrin Schultz
 Version	: 2.0
 Date		: Oct 2010

Content:

 Classes: EmissionProfile

 Determination of observed nucleotide and gap frequencies in a certain 
  consensus column (for match state) and successive non-consensus columns (insert state)
  for a certain subtype in the given alignment
***************************************************************/

#ifndef _EMISSIONPROFILE_H
#define _EMISSIONPROFILE_H


using namespace std;

class Alphabet;
class ConsColumnProfile;

class EmissionProfile
{
   friend ostream& operator<<(ostream& s, const EmissionProfile& e);
   public:
     EmissionProfile(ConsColumnProfile* cons_prof, const Alphabet& al);
     ~EmissionProfile(){};
     void check();

     int column()                const {return m_column;};
     int match_frequency(int i)  const;
     int insert_frequency(int i) const;

   private:
     int                m_column;
     vector<int>        m_match_frequencies;
     vector<int>        m_insert_frequencies;
};


ostream& operator<<(ostream& s, const EmissionProfile& e);


#endif  // _EMISSIONPROFILE_H
