// ~/jpHMM/rewrite_jpHMM/src/extEmTrProbs.h
/**************************************************************
 Dateiname	: extEmTrProbs.h
 Autor		: Ingo Bulla
 Version	: 2.0
 Datum		: Mai 2010

Inhalt:
 Klassen: ExtEmTrProbs

Aenderungen:
***************************************************************/

#ifndef _EXTEMTRPROBS_H
#define _EXTEMTRPROBS_H

#include "std_header.h"

using namespace std;



// contains emission and transition probabilities for match states given from external source
class ExtEmTrProbs
{
	friend ostream& operator<<(ostream& s, const ExtEmTrProbs& eetp);
public:
	ExtEmTrProbs(string em_probs_filename, string tr_probs_filename, string cons_file_name);
	vector<double> em_probs(string sub, unsigned pos) const { return m_em_probs.find(sub)->second.find(pos)->second; }
	vector<double> tr_probs(string sub, unsigned pos) const { return m_tr_probs.find(sub)->second.find(pos)->second; }
	bool is_cons_col(unsigned pos) const { return m_cons_cols.find(pos) != m_cons_cols.end(); }
private:
	map< string, map<unsigned, vector<double> > > m_em_probs;
	map< string, map<unsigned, vector<double> > > m_tr_probs;
	set<unsigned> m_cons_cols;
	
	static void read_probs(map< string, map<unsigned, vector<double> > >* probs, string probs_filename, unsigned num_probs);
};

ostream& operator<<(ostream& s, const ExtEmTrProbs& eetp);


#endif    // _EXTEMTRPROBS_H
