#ifndef IO_H
#define IO_H

#include "std_source.h" // TODO: ?

using namespace std;


// *****************************************************************************
// * Output of STL-container
// *****************************************************************************

template<class T> ostream& operator<<(ostream& s, const vector<T>& v)
{
	for (typename vector<T>::const_iterator it = v.begin(); it != v.end(); ++it)
		s << *it << " ";
	return s;
}



template<class T> ostream& operator<<(ostream& s, const vector<T*>& v)
{
	for (typename vector<T*>::const_iterator it = v.begin(); it != v.end(); ++it) {
		s << **it << " ";
	}
	return s;
}



template<class T> ostream& operator<<(ostream& s, const list<T>& l)
{
	for (typename list<T>::const_iterator it = l.begin(); it != l.end(); ++it)
		s << *it << " ";
	return s;
}



template<class T> ostream& operator<<(ostream& s, const list<T*>& l)
{
	for (typename list<T*>::const_iterator it = l.begin(); it != l.end(); ++it) {
		s << **it << " ";
	}
	return s;
}



template<class T> ostream& operator<<(ostream& s, const set<T>& l)
{
	for (typename set<T>::const_iterator it = l.begin(); it != l.end(); ++it) {
		s << *it << " ";
	}
	return s;
}



template<class T> ostream& operator<<(ostream& s, const set<T*>& l)
{
	for (typename set<T*>::const_iterator it = l.begin(); it != l.end(); ++it) {
		s << **it << " ";
	}
	return s;
}



template<class K, class V> ostream& operator<<(ostream& s, const map<K, V>& mp)
{
	for (typename map<K, V>::const_iterator it = mp.begin(); it != mp.end(); ++it)
		s << (*it).first << " => " << (*it).second << "   ";
	return s;
}

#endif
