// ~/jpHMM/src/transitionPriors.h
/**************************************************************
 File name	: transitionPriors.h
 Author		: Anne-Kathrin Schultz
 Version	: 2.0
 Date		: Oct 2010

Content:

 Classes: TransitionPriors

 Read in of priors (pseudo counts) for transition probabilities
***************************************************************/

#ifndef _TRANSITIONPRIORS_H
#define _TRANSITIONPRIORS_H


using namespace std;


class TransitionPriors
{
   friend ostream& operator<<(ostream& s, const TransitionPriors& t);
   public:
      TransitionPriors(string infile);
      ~TransitionPriors(){};
      void check();

      vector<mytype> make_vector() const {return m_trans_priors;};

  private:
      vector<mytype> m_trans_priors;
};

ostream& operator<<(ostream& s, const TransitionPriors& t);

#endif  // _TRANSITIONPRIORS_H
