// ~/jpHMM/src/transitionProfile.h
/**************************************************************
 File name	: transitionProfile.h
 Author		: Anne-Kathrin Schultz
 Version	: 2.0
 Date		: Oct 2010

Content:

 Classes: TransitionProfile

 Determination of observed transition frequencies 
  between different state types in the given sequences in the alignment
***************************************************************/


#ifndef _TRANSITIONPROFILE_H
#define _TRANSITIONPROFILE_H


using namespace std;

class TransAlphabet;
class ConsColumnProfile;

class TransitionProfile
{
   friend ostream& operator<<(ostream& s, const TransitionProfile& t_pr);
   public:
      TransitionProfile(ConsColumnProfile* cons_prof, const TransAlphabet& trans_alphabet);
      ~TransitionProfile(){};
      void check();

      int                column()      const {return m_column;};
      vector<int>        frequencies() const {return m_frequencies;};  //! A, C, G, T, X (sonstige), gaps - frequencies

  private:
      int                m_column;
      vector<int>        m_frequencies;

};

ostream& operator<<(ostream& s, const TransitionProfile& t_pr);

#endif  // _TRANSITIONPROFILE_H
